commit d5052ad6154256455aa2f9a603103ede61dae4b1
Author: Juergen Gross <jgross@suse.com>
Date:   Tue Jul 19 13:30:46 2016 +0200

    xenstore: use temporary memory context for firing watches
    
    Use a temporary memory context for memory allocations when firing
    watches. This will avoid leaking memory in case of long living
    connections and/or xenstore entries.
    
    This requires adding a new parameter to fire_watches() and add_event()
    to specify the memory context to use for allocations.
    
    Signed-off-by: Juergen Gross <jgross@suse.com>
    Reviewed-by: Wei Liu <wei.liu2@citrix.com>
    Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>

Index: xen-4.0.3-testing/tools/xenstore/xenstored_core.c
===================================================================
--- xen-4.0.3-testing.orig/tools/xenstore/xenstored_core.c
+++ xen-4.0.3-testing/tools/xenstore/xenstored_core.c
@@ -954,7 +954,7 @@ static void do_write(struct connection *
 
 	add_change_node(conn->transaction, name, false);
 	wrl_apply_debit_direct(conn);
-	fire_watches(conn, name, false);
+	fire_watches(conn, in, name, false);
 	send_ack(conn, XS_WRITE);
 }
 
@@ -980,7 +980,7 @@ static void do_mkdir(struct connection *
 		}
 		add_change_node(conn->transaction, name, false);
 		wrl_apply_debit_direct(conn);
-		fire_watches(conn, name, false);
+		fire_watches(conn, in, name, false);
 	}
 	send_ack(conn, XS_MKDIR);
 }
@@ -1107,7 +1107,7 @@ static void do_rm(struct connection *con
 	if (_rm(conn, node, name)) {
 		add_change_node(conn->transaction, name, true);
 		wrl_apply_debit_direct(conn);
-		fire_watches(conn, name, true);
+		fire_watches(conn, in, name, true);
 		send_ack(conn, XS_RM);
 	}
 }
@@ -1184,7 +1184,7 @@ static void do_set_perms(struct connecti
 
 	add_change_node(conn->transaction, name, false);
 	wrl_apply_debit_direct(conn);
-	fire_watches(conn, name, false);
+	fire_watches(conn, in, name, false);
 	send_ack(conn, XS_SET_PERMS);
 }
 
Index: xen-4.0.3-testing/tools/xenstore/xenstored_domain.c
===================================================================
--- xen-4.0.3-testing.orig/tools/xenstore/xenstored_domain.c
+++ xen-4.0.3-testing/tools/xenstore/xenstored_domain.c
@@ -183,7 +183,7 @@ static int destroy_domain(void *_domain)
 	if (domain->interface)
 		munmap(domain->interface, getpagesize());
 
-	fire_watches(NULL, "@releaseDomain", false);
+	fire_watches(NULL, domain, "@releaseDomain", false);
 
 	wrl_domain_destroy(domain);
 
@@ -218,7 +218,7 @@ static void domain_cleanup(void)
 	}
 
 	if (notify)
-		fire_watches(NULL, "@releaseDomain", false);
+		fire_watches(NULL, NULL, "@releaseDomain", false);
 }
 
 /* We scan all domains rather than use the information given here. */
@@ -382,7 +382,7 @@ void do_introduce(struct connection *con
 		/* Now domain belongs to its connection. */
 		talloc_steal(domain->conn, domain);
 
-		fire_watches(NULL, "@introduceDomain", false);
+		fire_watches(NULL, in, "@introduceDomain", false);
 	} else if ((domain->mfn == mfn) && (domain->conn != conn)) {
 		/* Use XS_INTRODUCE for recreating the xenbus event-channel. */
 		if (domain->port)
Index: xen-4.0.3-testing/tools/xenstore/xenstored_transaction.c
===================================================================
--- xen-4.0.3-testing.orig/tools/xenstore/xenstored_transaction.c
+++ xen-4.0.3-testing/tools/xenstore/xenstored_transaction.c
@@ -233,7 +233,7 @@ void do_transaction_end(struct connectio
 
 		/* Fire off the watches for everything that changed. */
 		list_for_each_entry(i, &trans->changes, list)
-			fire_watches(conn, i->node, i->recurse);
+			fire_watches(conn, in, i->node, i->recurse);
 		generation++;
 	}
 	send_ack(conn, XS_TRANSACTION_END);
Index: xen-4.0.3-testing/tools/xenstore/xenstored_watch.c
===================================================================
--- xen-4.0.3-testing.orig/tools/xenstore/xenstored_watch.c
+++ xen-4.0.3-testing/tools/xenstore/xenstored_watch.c
@@ -48,7 +48,12 @@ struct watch
 	char *node;
 };
 
+/*
+ * Send a watch event.
+ * Temporary memory allocations are done with ctx.
+ */
 static void add_event(struct connection *conn,
+		      void *ctx,
 		      struct watch *watch,
 		      const char *name)
 {
@@ -58,7 +63,7 @@ static void add_event(struct connection
 
 	if (!check_event_node(name)) {
 		/* Can this conn load node, or see that it doesn't exist? */
-		struct node *node = get_node(conn, name, name, XS_PERM_READ);
+		struct node *node = get_node(conn, ctx, name, XS_PERM_READ);
 		/*
 		 * XXX We allow EACCES here because otherwise a non-dom0
 		 * backend driver cannot watch for disappearance of a frontend
@@ -79,14 +84,19 @@ static void add_event(struct connection
 	}
 
 	len = strlen(name) + 1 + strlen(watch->token) + 1;
-	data = talloc_array(watch, char, len);
+	data = talloc_array(ctx, char, len);
 	strcpy(data, name);
 	strcpy(data + strlen(name) + 1, watch->token);
 	send_reply(conn, XS_WATCH_EVENT, data, len);
 	talloc_free(data);
 }
 
-void fire_watches(struct connection *conn, const char *name, bool recurse)
+/*
+ * Check whether any watch events are to be sent.
+ * Temporary memory allocations are done with ctx.
+ */
+void fire_watches(struct connection *conn, void *ctx, const char *name,
+		  bool recurse)
 {
 	struct connection *i;
 	struct watch *watch;
@@ -99,9 +109,9 @@ void fire_watches(struct connection *con
 	list_for_each_entry(i, &connections, list) {
 		list_for_each_entry(watch, &i->watches, list) {
 			if (is_child(name, watch->node))
-				add_event(i, watch, name);
+				add_event(i, ctx, watch, name);
 			else if (recurse && is_child(watch->node, name))
-				add_event(i, watch, watch->node);
+				add_event(i, ctx, watch, watch->node);
 		}
 	}
 }
@@ -170,7 +180,7 @@ void do_watch(struct connection *conn, s
 	send_ack(conn, XS_WATCH);
 
 	/* We fire once up front: simplifies clients and restart. */
-	add_event(conn, watch, watch->node);
+	add_event(conn, in, watch, watch->node);
 }
 
 void do_unwatch(struct connection *conn, struct buffered_data *in)
Index: xen-4.0.3-testing/tools/xenstore/xenstored_watch.h
===================================================================
--- xen-4.0.3-testing.orig/tools/xenstore/xenstored_watch.h
+++ xen-4.0.3-testing/tools/xenstore/xenstored_watch.h
@@ -26,7 +26,8 @@ void do_watch(struct connection *conn, s
 void do_unwatch(struct connection *conn, struct buffered_data *in);
 
 /* Fire all watches: recurse means all the children are affected (ie. rm). */
-void fire_watches(struct connection *conn, const char *name, bool recurse);
+void fire_watches(struct connection *conn, void *tmp, const char *name,
+		  bool recurse);
 
 void dump_watches(struct connection *conn);
 